<template>
<!-- ADVANCED SEARCH BUTTON -->
 <div clsss="advanced-btn-container">
    <button class="ecl-button ecl-button--primary advanced-btn" @click="openAdvanced()">  
    
     <span v-if="parameterCount >= 1" class="badge advanced-badge">{{ parameterCount }}</span> 
       <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sliders"
         viewBox="0 0 16 16">
         <path fill-rule="evenodd"
           d="M11.5 2a1.5 1.5 0 1 0 0 3 1.5 1.5 0 0 0 0-3M9.05 3a2.5 2.5 0 0 1 4.9 0H16v1h-2.05a2.5 2.5 0 0 1-4.9 0H0V3zM4.5 7a1.5 1.5 0 1 0 0 3 1.5 1.5 0 0 0 0-3M2.05 8a2.5 2.5 0 0 1 4.9 0H16v1H6.95a2.5 2.5 0 0 1-4.9 0H0V8zm9.45 4a1.5 1.5 0 1 0 0 3 1.5 1.5 0 0 0 0-3m-2.45 1a2.5 2.5 0 0 1 4.9 0H16v1h-2.05a2.5 2.5 0 0 1-4.9 0H0v-1z" />
       </svg>
       Advanced Search
     </button>
</div>
</template>

<script>
import { ref } from 'vue';

export default {
    name: "AdvancedSearchButton",
    setup() {
    //  const selectedFields = ref({});

    //  const parameterCount = ref(0);
    //  const advancedQuery = ref('');


    //   return {
    //     selectedFields,
    //     parameterCount,
    //     advancedQuery 
    //   }

    },
    data() {
    return {
      parameterCount: 0,
      advancedQuery: sessionStorage.getItem('query') || '',
      descQuery: sessionStorage.getItem('quedescQueryry') || '',
      titleQuery: sessionStorage.getItem('titleQuery') || '',
      advancedType: sessionStorage.getItem('selectedOption') || '',
      advancedFilter: sessionStorage.getItem('selectedFields') || '',
    };
  },
  methods: {
    openAdvanced() {
      this.$router.push({ name: 'AdvancedSearch' });
    },
    // utils/urlParams.js
   storeURLParameters() {
    try {
        const currentURL = window.location.href;
        const urlObj = new URL(currentURL);
        const params = new URLSearchParams(urlObj.search);

        // Define excluded keys
        const excludeKeys = ["locale", "query", "page"];
        

        // Build the parameters object
        const filters = {};

        for (const [key, value] of params.entries()) {
        if (!excludeKeys.includes(key)) {
          if (!filters[key]) {
            filters[key] = [];
          }
          filters[key].push(value);
        } else if (key === "query") {
          const fields = params.get("fields");
          if (fields === "title") {
            this.titleQuery = value;
            sessionStorage.setItem('titleQuery', this.titleQuery);
          } else if (fields === "description") {
            this.descQuery = value;
            sessionStorage.setItem('descQuery', this.descQuery);
          } else if (!fields) {
            this.advancedQuery = value;
            sessionStorage.setItem('query', this.advancedQuery);
          }
        }
      }

      // Save to sessionStorage
      sessionStorage.setItem('selectedFields', JSON.stringify(filters));

    } catch (error) {
      console.error("Error processing URL parameters:", error);
    }
    },
    getParameterCountFromBrowserURL() {
      try {
        // Get the current URL from the browser
        const currentURL = window.location.href;

        // Parse the URL using the URL constructor
        const urlObj = new URL(currentURL);

        // Get the search parameters from the URL
        const params = new URLSearchParams(urlObj.search);

        // List of parameters to exclude
        const excludeParams = ["filter", "locale", "query", "page", "sort", "minScoring", "limit"];

        // Filter and count only the parameters not in the exclude list
        const filteredCount = Array.from(params).filter(
          ([key]) => !excludeParams.includes(key)
        ).length;

        return filteredCount;
      } catch (error) {
        console.error("Error while processing the browser URL:", error);
        return 0; // Return 0 if something goes wrong
      }
    }
  },
  mounted() {
    this.parameterCount = this.getParameterCountFromBrowserURL();
    this.storeURLParameters();
  }
};

</script>

<style lang="scss" scoped>  

// Advanced search styles
.advanced-btn {
  margin-left: 5px;
  font-weight: 400;
  height: 48px;
}

.advanced-btn:hover {
  background-color: #3e6cd5 !important;
}

.advanced-btn svg {
  margin-right: 5px;
  vertical-align: text-top;
}

.advanced-badge {
  position: absolute;
  background-color: #fff;
  color: #0e47cb;
  margin-top: -8px;
  margin-left: 6px;
}

.advanced-btn-container {
position: relative;
}

</style>